; Includes
;--------------------------------
!include "MUI2.nsh"
!include "EnvVarUpdate.nsh"
!include nsDialogs.nsh
!include LogicLib.nsh
!include "FileFunc.nsh"
;--------------------------------
;  
Name "BARS Gateway v.2.3.1"
;--------------------------------
;  
OutFile "GatewaySetupAvtor.exe"
;--------------------------------
; -  
InstallDir C:\Bars\Gateway
BrandingText "BarsGateway copyright  UNITY-BARS 2013"
;--------------------------------
;     
; AutoCloseWindow true
;--------------------------------
;  
RequestExecutionLevel admin
;--------------------------------
;Interface Settings
  !define MUI_ABORTWARNING
  !define MUI_ICON  bars32.ico
;--------------------------------
  !define MUI_FINISHPAGE_TITLE " "
; Pages
  !insertmacro MUI_PAGE_DIRECTORY
  ;Page directory
  ;!insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

  ;Page finish
;--------------------------------
; Languages
  !insertmacro MUI_LANGUAGE "Ukrainian"
;--------------------------------
  ;XPStyle on

;LoadLanguageFile "${NSISDIR}\Contrib\Language files\Ukrainian.nlf"
;UninstPage uninstConfirm
;UninstPage instfiles

;--------------------------------
; Variables
Function .onInit
   System::Call 'kernel32::CreateMutexA(i 0, i 0, t "setup.gateway") i .r1 ?e'
   Pop $R0

   StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION " Bars Gateway  ."
   Abort
FunctionEnd
;--------------------------------
; The stuff to install
Section "Bars Gateway" SecMain
  SectionIn RO

  SetShellVarContext all
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File /r /x Gateway.nsi /x backup /x GatewaySetup*.* /x bars32.ico *.*


  ; install vcredist
  ExecWait "$INSTDIR\vcredist_x86.exe"

  ; Write the installation path into the registry
  ;WriteRegStr HKLM "SOFTWARE\UNITY-BARS\BARS Gateway\1.00.000" "" " "
  WriteRegStr HKLM "SOFTWARE\UnityBars\Gateway" "Config" "$INSTDIR\config\gateway.xml"
  WriteRegStr HKLM "SOFTWARE\UnityBars\Gateway" "Path" "$INSTDIR\bin\barsgtw.exe"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BarsGateway" "DisplayName" "BARS Gateway"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BarsGateway" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BarsGateway" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BarsGateway" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
  ;Avtor
  WriteRegStr HKLM "Software\UnityBars\Gateway\AvtorCL2" "Pkcs11Libs" "$INSTDIR\avtor\bin\Av337CryptokiD.dll"
  WriteRegStr HKLM "Software\UnityBars\Gateway\AvtorCL2" "CertStore" "$INSTDIR\avtor\public\"
  WriteRegStr HKLM "Software\UnityBars\Gateway\AvtorCL2" "TrustedCertStore" "$INSTDIR\avtor\public\trusted\"
  WriteRegStr HKLM "Software\UnityBars\Gateway\AvtorCL2" "DefaultUser" "User"

  WriteRegStr HKCU "Software\UnityBars\Gateway\AvtorCL2" "Pkcs11Libs" "$INSTDIR\avtor\bin\Av337CryptokiD.dll"
  WriteRegStr HKCU "Software\UnityBars\Gateway\AvtorCL2" "CertStore" "$INSTDIR\avtor\public\"
  WriteRegStr HKCU "Software\UnityBars\Gateway\AvtorCL2" "TrustedCertStore" "$INSTDIR\avtor\public\trusted\"
  WriteRegStr HKCU "Software\UnityBars\Gateway\AvtorCL2" "DefaultUser" "User"
  
  CreateDirectory "$INSTDIR\avtor\public\"
    CreateDirectory "$INSTDIR\avtor\public\trusted\"
  ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\bin"
  ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\avtor\bin"

  CreateDirectory "$SMPROGRAMS\UNITY-BARS\BARS Gateway"
  CreateShortCut "$SMPROGRAMS\UNITY-BARS\BARS Gateway\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\UNITY-BARS\BARS Gateway\BARS Gateway.lnk" "$INSTDIR\bin\barsgtw.exe" "$INSTDIR\config\gateway.xml" "$INSTDIR\bin\barsgtw.exe" 0
  
  CreateShortCut "$DESKTOP\BARS Gateway.lnk" "$INSTDIR\bin\barsgtw.exe" "$INSTDIR\config\gateway.xml" "$INSTDIR\bin\barsgtw.exe" 0
SectionEnd

;--------------------------------
; Uninstaller

Section "Uninstall"
  
  SetShellVarContext all
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BarsGateway"
  DeleteRegKey HKLM "Software\UnityBars\Gateway"
  DeleteRegKey HKLM "Software\UNITY-BARS\BARS Gateway"

  ; Remove files and uninstaller
  Delete $INSTDIR\*.*
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\UNITY-BARS\BARS Gateway\*.*"
  Delete "$SMSTARTUP\BARS Gateway*"
  Delete "$DESKTOP\BARS Gateway*"

  ; Remove directories used
  RMDir /r "$SMPROGRAMS\UNITY-BARS\BARS Gateway"
  RMDir /r "$INSTDIR"
  
  ; Path
  ${un.EnvVarUpdate} $0 "PATH" "R" "HKLM" "$INSTDIR\bin"

SectionEnd
